<?php
/**
 * @version 2.0 2012-03-07
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the Thinkery
 * @license GNU/GPL see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');
jimport('joomla.log.log');

class IpropertyControllerAjax extends JController
{
	protected $text_prefix = 'COM_IPROPERTY';
    
    public function resetHits()
    {
        // Check for request forgeries
        JRequest::checkToken() or die( 'Invalid Token' );
        $prop_id = JRequest::getInt('prop_id');
        
        $db     = JFactory::getDbo();
        $query  = 'UPDATE #__iproperty SET hits = 0 WHERE id = '.(int)$prop_id.' LIMIT 1';
        $db->setQuery($query);
        
        if($db->Query()){
            echo JText::_('COM_IPROPERTY_COUNTER_RESET');
        }else{
            return false;
        }
    }

    public function checkUserAgent()
    {
        // Check for request forgeries
        JRequest::checkToken() or die( 'Invalid Token' );
        $user_id = JRequest::getInt('user_id');
        $agent_id = JRequest::getInt('agent_id', 0);

        if(!$user_id) return false;

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);

        $query->select('id');
        $query->from('#__iproperty_agents');
        $query->where('user_id = '.(int)$user_id);
        $query->where('id != '.(int)$agent_id);
        $db->setQuery($query);

        echo $db->loadResult();
    }
    
    function displayStypes()
    {
        JRequest::checkToken('get') or die( 'Invalid Token' );
        JHTML::_('behavior.tooltip');
        $model = $this->getModel('settings');
        
        $i = 0;
        $html = '';        
        if ($stypes = $model->getStypes()) {
            $k = 0;
            for($i = 0, $n = count( $stypes ); $i < $n; $i++){
                $stype = $stypes[$i];
                $pchecked = ($stype->state) ? ' checked="checked"' : '';
                $bchecked = ($stype->show_banner) ? ' checked="checked"' : '';

                $html .= '
                <tr class="stype_row row'.$k.'">
                    <td><input type="hidden" id="ipstype" value="'.$stype->id.'" class="s'.$i.'"/><input type="text" id="name" class="inputbox s'.$i.'" value="'.JText::_($stype->name).'" style="width: 100%;" /></td>
                    <td><input type="text" id="banner_image" class="inputbox s'.$i.'" value="'.$stype->banner_image.'" style="width: 100%;" /></td>
                    <td><input type="text" id="banner_color" class="inputbox s'.$i.'" value="'.$stype->banner_color.'" style="width: 100%;" /></td>
                    <td align="center"><input type="checkbox" id="state" class="inputbox s'.$i.'" value="1"'.$pchecked.' /></td>
                    <td align="center"><input type="checkbox" id="show_banner" class="inputbox s'.$i.'" value="1"'.$bchecked.' /></td>
                    <td align="center">'.$stype->id.'</td>
                    <td><a href="javascript:void(0);" onclick="if(confirm(\''.JText::_( 'COM_IPROPERTY_CONFIRM_DELETE' ).'\')){deleteStype('.$stype->id.');}">delete</a></td>
                </tr>';
                $k = 1 - $k;
            }
        }else{
            $html .= '<tr><td class="center" colspan="7">'.JText::_('COM_IPROPERTY_NO_RESULTS').'</td></tr>';
        }
        $html .= '
            <tr><td colspan="7">&nbsp;</td></tr>
            <tr><td colspan="7" style="background: #0093D4 !important; color: #fff !important;"><b>Add new:</b></td></tr>
            <tr class="stype_row">
                <td><input type="hidden" id="ipstype" value="new" class="s'.$i.'"/><input type="text" id="name" class="inputbox s'.$i.'" value="" style="width: 100%;" /></td>
                <td><input type="text" id="banner_image" class="inputbox s'.$i.'" value="" style="width: 100%;" /></td>
                <td><input type="text" id="banner_color" class="inputbox s'.$i.'" value="" style="width: 100%;" /></td>
                <td align="center"><input type="checkbox" id="state" class="inputbox s'.$i.'" value="1" checked="checked" /></td>
                <td align="center"><input type="checkbox" id="showbanner" class="inputbox s'.$i.'" value="1" /></td>
                <td colspan="2"><input type="button" onclick="saveStypes(); return false;" value="'.JText::_( 'COM_IPROPERTY_ADD' ).'" /></td>
            </tr>';
        echo $html;
    }

    function saveStypes()
    {
        JRequest::checkToken() or die( 'Invalid Token' );
        $data  = JRequest::get( 'post' );
        if(!$stypes = json_decode($data['stypes'])){
            //die( 'Invalid Data' );
            echo '
                <dl id="system-message">
                    <dt class="error">Error</dt>
                    <dd class="error message">
                        <ul>
                            <li>Invalid Data: '.$data['stypes'].'</li>
                        </ul>
                    </dd>
                </dl>';
            return;
        }

        $model = $this->getModel('settings');
        if($model->saveStypes( $stypes )){
            echo '
                <dl id="system-message">
                    <dt class="message">Message</dt>
                    <dd class="message message">
                        <ul>
                            <li>Success</li>
                        </ul>
                    </dd>
                </dl>';
        }else{
            echo '
                <dl id="system-message">
                    <dt class="error">Error</dt>
                    <dd class="error message">
                        <ul>
                            <li>'.$model->getError().'</li>
                        </ul>
                    </dd>
                </dl>';
        }            
    }  

    function deleteStype()
    {
        JRequest::checkToken() or die( 'Invalid Token' );
        $stypeid    = JRequest::getInt('id');
        $model      = $this->getModel('settings');
        if($model->deleteStype($stypeid)){
            echo '
                <dl id="system-message">
                    <dt class="message">Message</dt>
                    <dd class="message message">
                        <ul>
                            <li>Success</li>
                        </ul>
                    </dd>
                </dl>';
        }else{
            echo '
                <dl id="system-message">
                    <dt class="error">Error</dt>
                    <dd class="error message">
                        <ul>
                            <li>'.$model->getError().'</li>
                        </ul>
                    </dd>
                </dl>';
        }
    }
    
    /**********************
     * Gallery functions
     **********************/
    
    function ajaxLoadGallery()
    {
		/**
		* Pulls images from IP images table
		*
		* @param integer $propid ID of property 
		* @param integer $own Whether we want only our own images or all avail
		* @param integer $limitstart Starting record id
		* @param integer $limit Max rows to return
		* @param string $token Joomla token
		* @return JSON encoded image data
		*/ 
		// Check for request forgeries
		JRequest::checkToken('get') or die( 'Invalid Token' );

		$propid 	= JRequest::getInt('propid');
		$own		= JRequest::getInt('own');
		$limitstart	= JRequest::getInt('limitstart');
		$limit		= JRequest::getInt('limit');

		if (!$propid ){
			JError::raiseError(500, JText::_( 'NO PROPID SELECTED' ) );
		}
		$model = $this->getModel('gallery');
		echo json_encode($model->loadGallery($propid, $own, $limitstart, $limit));
	}
    
    function ajaxLoadFiles()
    {
		/**
		* Pulls files from IP images table
		*
		* @param integer $propid ID of property 
		* @param string $token Joomla token
		* @return JSON encoded image data
		*/ 
		// Check for request forgeries
		JRequest::checkToken('get') or die( 'Invalid Token' );

        $propid 	= JRequest::getInt('propid');
        $own		= JRequest::getBool('own');

		if (!$propid ){
			JError::raiseError(500, JText::_( 'NO PROPID SELECTED' ) );
		}
		$model = $this->getModel('gallery');
		echo json_encode($model->loadFiles($propid, $own));
	}    
	
	function ajaxDelete()
    {
		/**
		* Deleted image from IP images table, and deleted image file if it's not in use with other listing
		*
		* @param integer $rowid ID of image 
		* @param string $token Joomla token
		* @return true or false
		*/ 
		// Check for request forgeries
		JRequest::checkToken('get') or die( 'Invalid Token' );
		
		$rowid		= JRequest::getInt('imgid');
		
		if (!$rowid ){
			JError::raiseError(500, JText::_( 'NO IMAGE ID SELECTED' ) );
		}
		$model = $this->getModel('gallery');
		echo $model->delete($rowid);	
	}
	
	function ajaxAdd()
    {
		/**
		* Add existing image to IP listing
		*
		* @param integer $propid ID of property
		* @param integer $rowid ID of image
		* @param string $token Joomla token
		* @return true or false
		*/ 
		// Check for request forgeries
		JRequest::checkToken('get') or die( 'Invalid Token' );
		
		$propid		= JRequest::getInt('propid');
		$rowid		= JRequest::getInt('imgid');
		
		if (!$propid ){
			JError::raiseError(500, JText::_( 'NO LISTING ID SELECTED' ) );
		}
		$model = $this->getModel('gallery');
		echo json_encode($model->ajaxAddImage($propid, $rowid));	
	}

	function ajaxSort()
    {
		/**
		* Save image order/titles/desc for listing
		*
		* @param string $data JSON encoded sort data for property
		* @param string $token Joomla token
		* @return true or false
		*/ 
		// Check for request forgeries
		JRequest::checkToken('get') or die( 'Invalid Token' );
		
		$data		= JRequest::getVar('data');
		$data		= json_decode($data);
		
		if (!$data ){
			JError::raiseError(500, JText::_( 'NO SORT DATA INCLUDED' ) );
		}
		$model = $this->getModel('gallery');
		echo $model->ajaxSort($data);
	}
	
	function ajaxUploadRemote()
    {
		/**
		* Save remote image for listing
		*
		* @param int $propid ID of property
		* @param string $path Remote file location
		* @param string $token Joomla token
		* @return true or false
		*/ 
		// Check for request forgeries
		JRequest::checkToken('get') or die( 'Invalid Token' );
		
		$propid		= JRequest::getInt('propid');
		$path		= JRequest::getString('path');
		
		if (!$propid ){
			JError::raiseError(500, JText::_( 'NO PROPID INCLUDED' ) );
		}
		$model = $this->getModel('gallery');
		echo json_encode($model->uploadRemote($propid, $path));
	}	
    
    function ajaxUpload()
    {
		/**
		* Upload image for listing, resize, rename, move
		*
		* @param int $propid ID of property
		* @param string $file Local file info array
		* @param string $token Joomla token
		* @return success or failure message
		*/ 
		// Check for request forgeries
		JRequest::checkToken('get') or die( 'Invalid Token' );
 
		$propid		= JRequest::getInt('propid');
		$files		= JRequest::get('FILES'); // this should be an array
		$status     = array();

        if (!isset($_FILES['file']['tmp_name']) && !is_uploaded_file($_FILES['file']['tmp_name'])) {
            $error = 'Invalid Upload';
            echo $error;
            die(JText::_( 'INVALID UPLOAD' ));
        } 
        
		if (!$propid || !count($files)){
			//JError::raiseError(500, JText::_( 'NO PROPID INCLUDED OR NO FILE ARRAY FOUND' ) );
            $status[0] = array( 'status' => 0,
                                'propid' => $propid,
                                'result' => 'propid or no file found'
                                );
            echo json_encode($files); 
            die(JText::_( 'NO PROPID INCLUDED OR NO FILE ARRAY FOUND' ));
		}
        
        foreach($files as $file){
            $model      = $this->getModel('gallery');
            $result     = $model->uploadIMG($file, $propid);
            
            if(!$result){
                $status['status']  = 0;
                $status['fname']   = $file['tmp_name'];
                $status['result']  = $result;
            } else if ($result == 'overlimit') {
                $status['status']  = 0;
                $status['result']  = $result;
            } else {
                $status['status']  = 1;
                $status['fname']   = $file['tmp_name'];
                $status['result']  = $result;
            }
        }
        echo json_encode($status); 
	}    
}
?>
