<?php
/**
 * @version 2.0 2012-03-07
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the Thinkery
 * @license GNU/GPL see LICENSE.php
 */

defined('JPATH_BASE') or die;

jimport('joomla.html.html');
jimport('joomla.form.formfield');

class JFormFieldDatetime extends JFormField
{
    protected $type = 'Datetime';

	protected function getInput()
	{
		$document = JFactory::getDocument();
        $document->addScript(JURI::root(true).'/components/com_iproperty/assets/js/datepicker.js');
        $document->addStyleSheet(JURI::root(true).'/components/com_iproperty/assets/css/datepicker_vista.css');
        $size = $this->element['size'] ? $this->element['size'] : 30;
        
        $days   = array("'".JText::_('SUNDAY')."', '".JText::_('MONDAY')."', '".JText::_('TUESDAY')."', '".JText::_('WEDNESDAY')."', '".JText::_('THURSDAY')."', '".JText::_('FRIDAY')."', '".JText::_('SATURDAY')."'");
        $months = array("'".JText::_('JANUARY')."', '".JText::_('FEBRUARY')."', '".JText::_('MARCH')."', '".JText::_('APRIL')."', '".JText::_('MAY')."', '".JText::_('JUNE')."', '".JText::_('JULY')."', '".JText::_('AUGUST')."', '".JText::_('SEPTEMBER')."', '".JText::_('OCTOBER')."', '".JText::_('NOVEMBER')."', '".JText::_('DECEMBER')."'");
        
        $js = "
        window.addEvent('load', function() {
            new DatePicker('.date_time_".$this->element['name']."', 
                            { pickerClass: 'datepicker_vista', 
                              allowEmpty: true,
                              timePicker: true, 
                              format: 'Y-m-d H:i',
                              days: [".implode(',', $days)."],
                              months: [".implode(',', $months)."],
                              inputOutputFormat: 'Y-m-d H:i'});
        });";
        
        $document->addScriptDeclaration($js);
        
        return '<input name="'.$this->name.'" type="text" value="'.$this->value.'" size="'.$size.'" class="date inputbox date_time_'.$this->element['name'].'" />';
	}
}