<?php
/**
 * @version 2.0 2012-03-07
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the Thinkery
 * @license GNU/GPL see LICENSE.php
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin');

$pluginpath = JPATH_PLUGINS.DS.'iproperty'.DS.'tweetlisting';

require $pluginpath.DS.'assets'.DS.'tmhOAuth.php';
require $pluginpath.DS.'assets'.DS.'tmhUtilities.php';

class plgIpropertyTweetlisting extends JPlugin
{	
	function plgIpropertyTweetlisting(&$subject, $config)  
    {
		parent::__construct($subject, $config);
        $this->loadLanguage();
	}

	function onAfterSavePropertyEdit($prop_id, $isNew, $settings)
	{
        $app = JFactory::getApplication();
        $document = JFactory::getDocument();
        
        $tweetnew = $this->params->get('tweetnew', false);
        $tweetupd = $this->params->get('tweetupdate', false);
        
        // only tweet new or updated if params are true
        if($isNew && !$tweetnew) return false;
        if(!$isNew && !$tweetupd) return false;
        
        $ckey = $this->params->get('consumer', false);
        $csec = $this->params->get('csecret', false);
        $toke = $this->params->get('token', false);
        $asec = $this->params->get('asecret', false);
        
        if( !$ckey || !$csec || !$toke || !$asec ) return false;
        
        $link = $property->proplink;
        $link = $this->shortenUrl($link);
        
        $message =  $isNew ? JText::_('PLG_IP_TWEETLISTING_TWEET_NEW_TEXT') : JText::_('PLG_IP_TWEETLISTING_TWEET_NEW_TEXT');
        $message .= '@ '.$link;  
        if($this->params->get('showprice', false)) $message .= ' - '.$property->price;
        
        $tmhOAuth = new tmhOAuth(array(
                                    'consumer_key'    => $ckey,
                                    'consumer_secret' => $csec,
                                    'user_token'      => $toke,
                                    'user_secret'     => $asec,
                                ));

        $code = $tmhOAuth->request('POST', $tmhOAuth->url('1/statuses/update'), array(
            'status' => $message
        ));
        
        if ($code == 200) {
            tmhUtilities::pr(json_decode($tmhOAuth->response['response']));
        } else {
            tmhUtilities::pr($tmhOAuth->response['response']);
        }
        
        return true;
	}
    
    function shortenURL($url)
    {
        $reqdata = array('longUrl' => $url);
        
        // add the API key if they have one
        if ($key) $reqdata['key'] = $key;
        $reqdata = json_encode($reqdata);
        
        $ch = curl_init("https://www.googleapis.com/urlshortener/v1/url");
        curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json")); 
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $reqdata);             
        $response = curl_exec($ch);
        curl_close($ch);
   
        $json = json_decode($response);
        $shorturl = $json->id;
    
        return $shorturl;
    }
}