<?php
/**
 * @version 2.0 2012-03-07
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the Thinkery
 * @license GNU/GPL see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.error.log');

class ipropertyController extends JController
{
    var $log;
    var $debug;

    function __construct()
    {
        $this->debug = false;
        if($this->debug) $this->log =JLog::getInstance('iproperty.log.php'); // create the logfile TODO: maybe add a debug switch to the admin to turn this off or on
        if($this->debug) $this->log->addEntry(array('COMMENT' => 'Constructing IProperty'));
        
        parent::__construct();       
    }
    
    public function display($cachable = false, $urlparams = false)
	{
		$app            = JFactory::getApplication();
        $document       = JFactory::getDocument();
        $settings       = ipropertyAdmin::config();       
        
        if( $settings->offline == 1 ){
            echo '
                <div align="center">
                    '.JHTML::_('image.site', 'iproperty1.png','/components/com_iproperty/assets/images/','','','').'
                    <div style="margin-top: 10px;"><strong>' . $settings->offmessage . '</strong></div>
                </div>';
        }else{
            // Set predefined 'get' vars from menu item params
            $pdarray = array('cat', 'stype', 'city', 'locstate', 'province', 'county', 'region', 'country', 'beds', 'baths', 'price_low', 'price_high', 'filter_order', 'filter_order_dir');
            foreach($pdarray as $pd){
                if($app->getParams()->get($pd)){
                    JRequest::setVar($pd, $app->getParams()->get($pd), 'get');
                }
            }
            // end predefined vars
            
            $altrowstyle    = '.iprow0{background: '.$settings->secondary_accent.'; border: 0px !important;}';
            $document->addStyleDeclaration($altrowstyle);
        
            $cachable       = true;
            $editid         = JRequest::getInt('id');
            $vName          = JRequest::getCmd('view', 'home');
            
            JRequest::setVar('view', $vName);

            $safeurlparams = array('cat'=>'INT','id'=>'INT','cid'=>'ARRAY','limit'=>'INT','limitstart'=>'INT',
                'showall'=>'INT','return'=>'BASE64','search'=>'STRING','filter_order'=>'CMD','filter_order_dir'=>'CMD',
                'stype'=>'INT','print'=>'BOOLEAN','city'=>'STRING','locstate'=>'INT','province'=>'STRING','county'=>'STRING',
                'region'=>'STRING','country'=>'INT','beds'=>'INT','baths'=>'INT','price_low'=>'INT','price_high'=>'INT');

            parent::display($cachable, $safeurlparams);

            return $this;
        }
	}
}
?>