<?php
/**
 * @version 2.0 2012-03-07
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the Thinkery
 * @license GNU/GPL see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.view');

class IpropertyViewAdvsearch extends JView
{
	function display($tpl = null)
	{
		$app            = JFactory::getApplication();
        $option         = JRequest::getCmd('option');
        $itemid         = (JRequest::getInt('recallSearch')) ? JRequest::getInt('recallSearch') : JRequest::getInt('Itemid', 99999);
        $this->params   = $app->getParams();
        
		JHTML::_('behavior.tooltip');
        JPluginHelper::importPlugin( 'iproperty' );
        $dispatcher = JDispatcher::getInstance();

		$this->ipbaseurl    = JURI::root(true);
        $document           = JFactory::getDocument();
		$settings           = ipropertyAdmin::config();
        $user               = JFactory::getUser();
        $this->ipauth       = new ipropertyHelperAuth();
        $this->accent_color = ( $settings->accent ) ? $settings->accent : '#d2e4ea';

        if(!$settings->googlemap_enable){
            $this->_displayNoAccess();
            return;
        }

        $document->addStyleSheet($this->ipbaseurl.'/components/com_iproperty/assets/css/'.$settings->css_file);
        $document->addStyleSheet($this->ipbaseurl.'/components/com_iproperty/assets/css/advsearch.css');
        // this is the google v3 maps api, no key required
        $document->addScript('http://maps.google.com/maps/api/js?sensor=false');
        $document->addScript($this->ipbaseurl.'/components/com_iproperty/assets/js/ipGmap.js');
        $document->addScript($this->ipbaseurl.'/components/com_iproperty/assets/js/Slider.js');
        $document->addScript($this->ipbaseurl.'/components/com_iproperty/assets/js/Slider.Extra.js');

        $model          = $this->getModel();
        $properties		= $this->get('data');
        $totalprops     = $this->get('total');

        //create toolbar
        $dispatcher->trigger( 'onBeforeRenderToolbar', array( &$settings ) );
        $extra = array();
        echo ipropertyHTML::buildToolbar('advsearch', $extra);      

        $this->assignRef('settings', $settings);
        $this->assignRef('dispatcher', $dispatcher);
        $this->assignRef('user', $user);

        $munits = (!$settings->measurement_units) ? JText::_( 'COM_IPROPERTY_SQFT2' ) : JText::_( 'COM_IPROPERTY_SQM2' );

        // check for template map and property preview icons
        $map_house_icon     = '/components/com_iproperty/assets/images/map/icon56.png';
        $map_preview_icon   = '/components/com_iproperty/assets/images/map/map_preview.png';
        $prop_preview_icon  = '/components/com_iproperty/assets/images/map/prop_preview.png';
        $templatepath        = $app->getTemplate();
        if(JFile::exists('templates'.DS.$templatepath.DS.'images'.DS.'iproperty'.DS.'map'.DS.'icon56.png')) $map_house_icon = '/templates/'.$templatepath.'/images/iproperty/map/icon56.png';
        if(JFile::exists('templates'.DS.$templatepath.DS.'images'.DS.'iproperty'.DS.'map'.DS.'map_preview.png')) $map_preview_icon = '/templates/'.$templatepath.'/images/iproperty/map/map_preview.png';
        if(JFile::exists('templates'.DS.$templatepath.DS.'images'.DS.'iproperty'.DS.'map'.DS.'prop_preview.png')) $prop_preview_icon = '/templates/'.$templatepath.'/images/iproperty/map/prop_preview.png';

        $mapscript = "
        var langOptions = {
            tprop:'".addslashes(JText::_('COM_IPROPERTY_RESULTS'))."',
            price:'".addslashes(JText::_('COM_IPROPERTY_PRICE'))."',
            nolimit: '".addslashes(JText::_('COM_IPROPERTY_NO_LIMIT'))."',
            pid: '".addslashes(JText::_('COM_IPROPERTY_PROPERTY_ID'))."',
            street: '".addslashes(JText::_('COM_IPROPERTY_STREET'))."',
            beds: '".addslashes(JText::_('COM_IPROPERTY_BEDS'))."',
            baths: '".addslashes(JText::_('COM_IPROPERTY_BATHS'))."',
            sqft: '".addslashes($munits)."',
            preview: '".addslashes(JText::_('COM_IPROPERTY_PREVIEW'))."',
            more: '".addslashes(JText::_('COM_IPROPERTY_MORE' ))."',
            inputText: '".addslashes(JText::_('COM_IPROPERTY_INPUT_TIP'))."',
            noRecords: '".addslashes(JText::_('COM_IPROPERTY_NO_RECORDS_TEXT'))."',
            previous: '".addslashes(JText::_('COM_IPROPERTY_PREVIOUS'))."',
            next: '".addslashes(JText::_('COM_IPROPERTY_NEXT'))."',
            of: '".addslashes(JText::_('COM_IPROPERTY_OF'))."',
            searchopt: '".addslashes(JText::_('COM_IPROPERTY_SEARCH_OPTIONS'))."',
            savesearch: '".addslashes(JText::_('COM_IPROPERTY_SAVESEARCH'))."',
            clearsearch: '".addslashes(JText::_('COM_IPROPERTY_CLEARSEARCH'))."'
        };

        var mapOptions = {
            zoom: ".$this->params->get('adv_default_zoom', $settings->adv_default_zoom).",
            maxZoom: ".$this->params->get('max_zoom', $settings->max_zoom).",
            mapTypeId: google.maps.MapTypeId.".$this->params->get('adv_maptype', $settings->adv_maptype).",
            lat: '".$this->params->get('adv_default_lat', $settings->adv_default_lat)."',
            lng: '".$this->params->get('adv_default_long', $settings->adv_default_long)."'
        }

        var searchOptions = {
			limit: ".$this->params->get('adv_perpage', $settings->adv_perpage)."
		}

        var inputOptions = {
            ".$this->_getInputs($settings)."
        }

        var sliderOptions = {
            ".$this->_getSliders($settings)."
        }

		window.addEvent((window.webkit) ? 'load' : 'domready', function(){
			var pw = new PropertyWidget($('mapCanvas'),{
                ipbaseurl: '".JURI::root()."',
                sliderLength: ".$this->params->get('adv_slider_length', $settings->adv_slider_length).",
                Itemid: ".$itemid.",
                showPreview: '".$this->params->get('adv_show_preview', $settings->adv_show_preview)."',
                noLimit: ".$this->params->get('adv_nolimit', $settings->adv_nolimit).",
                currencyFormat: '".$this->params->get('nformat', $settings->nformat)."',
                currencySymbol: '".$this->params->get('currency', $settings->currency)."',
                currencyPos: '".$this->params->get('currency_pos', $settings->currency_pos)."',
                marker: '".$map_house_icon."',
                token: '".JFactory::getSession()->getFormToken()."',
                thumbnail: ".$this->params->get('adv_show_thumb', $settings->adv_show_thumb).",
                slideColor: '".$this->params->get('accent', $settings->accent)."',
                mapWidth: ".$this->params->get('adv_map_width', $settings->adv_map_width).",
                mapHeight: ".$this->params->get('adv_map_height', $settings->adv_map_height).",
                mapPreviewIcon: '".$map_preview_icon."',
                propPreviewIcon: '".$prop_preview_icon."',
                saveSearch: '".$settings->show_savesearch."',
                radiusSearch: '".$this->params->get('adv_show_radius', $settings->adv_show_radius)."',
                text: langOptions,
                map: mapOptions,
                search: searchOptions,
                inputs: inputOptions,
                sliders: sliderOptions                
            });
		});";
        $document->addScriptDeclaration($mapscript);

        $this->_prepareDocument();
        parent::display($tpl);
    }

    protected function _prepareDocument() 
    {
		$app            =& JFactory::getApplication();
		$menus          = $app->getMenu();
		$pathway        = $app->getPathway();
		$this->params   = $app->getParams();
		$title          = null;

        $menu = $menus->getActive();
		if ($menu) {
			$this->params->def('page_heading', $this->params->get('page_title', $menu->title));
		} else {
			$this->params->def('page_heading', JText::_( 'COM_IPROPERTY_INTELLECTUAL_PROPERTY' ));
		}

		$title = (is_object($menu) && $menu->query['view'] == 'advsearch') ? $this->params->get('page_title', '') : JText::_( 'COM_IPROPERTY_ADVANCED_SEARCH' );
        $this->iptitle = $title;
        if (empty($title)) {
			$title = $app->getCfg('sitename');
		}
		elseif ($app->getCfg('sitename_pagetitles', 0) == 1) {
			$title = JText::sprintf('JPAGETITLE', $app->getCfg('sitename'), $title);
		}
		elseif ($app->getCfg('sitename_pagetitles', 0) == 2) {
			$title = JText::sprintf('JPAGETITLE', $title, $app->getCfg('sitename'));
		}
		$this->document->setTitle($title);

        // Set meta data according to menu params
        if ($this->params->get('menu-meta_description', '')) $this->document->setDescription($this->params->get('menu-meta_description', ''));
        if ($this->params->get('menu-meta_keywords', '')) $this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords', ''));
        if ($this->params->get('robots')) $this->document->setMetadata('robots', $this->params->get('robots'));

		// Breadcrumbs
        if(is_object($menu) && $menu->query['view'] != 'advsearch') {
			$pathway->addItem($title);
		}
	}

    function _displayNoAccess($tpl = 'noaccess')
    {
        $app  =& JFactory::getApplication();
        $option     = JRequest::getCmd('option');

        $this->ipbaseurl    = JURI::root(true);
        $document           = JFactory::getDocument();
		$settings           = ipropertyAdmin::config();
        $pathway            = $app->getPathway();

        // Get the menu item object
        $menus =& JSite::getMenu();
        $menu  = $menus->getActive();
        $document->addStyleSheet($this->ipbaseurl.'/components/com_iproperty/assets/css/'.$settings->css_file);

        $document->setTitle( JText::_( 'COM_IPROPERTY_ADVANCED_SEARCH' ));
        //set breadcrumbs
        if(is_object($menu) && $menu->query['view'] != 'advsearch') {
            $pathway->addItem(JText::_( 'COM_IPROPERTY_ADVANCED_SEARCH' ), '');
        }

        $this->assignRef('settings', $settings);
        $this->accent_color = ( $this->settings->accent ) ? $this->settings->accent : '#d2e4ea';

        parent::display($tpl);
    }

    protected function _getInputs($settings)
    {
        $input_script = '';
        
        $lists = array();
        $lists['cities']    = ipropertyHTML::city_select_list('', '', '', true);

        //Sale types
        if($this->params->get('adv_show_stype', $settings->adv_show_stype)){
            $lists['stypes']    = ipropertyHTML::stype_select_list('', '', '', true, true);

            $stypes = array();
            foreach($lists['stypes'] as $st){
                if($st->value) $stypes[] = "'".addslashes($st->text)."': ".(int)$st->value;
            }
            $input_script .=
            "'stype': {
                title: '".addslashes(JText::_('COM_IPROPERTY_SALE_TYPE'))."',
                tag: 'select',
                parameter: 'stype',
                value: {".implode(',', $stypes)."},
                disabled: false,
                group: 'stype',
                selected: false
            },";
        }

        //Cities
        $cities = array();
        foreach($lists['cities'] as $ci){
            if($ci->value) $cities[] = "'".addslashes($ci->text)."': '".addslashes($ci->value)."'";
        }
        $input_script .=
        "'city': {
            title: '".addslashes(JText::_('COM_IPROPERTY_CITY'))."',
            tag: 'select',
            parameter: 'city',
            value: {".implode(',', $cities)."},
            group: 'location',
            selected: false
        },";

        //Regions
        if($this->params->get('adv_show_region', $settings->adv_show_region)){
            $lists['regions']   = ipropertyHTML::region_select_list('', '', '', true);
            
            $regions = array();
            foreach($lists['regions'] as $r){
                if($r->value) $regions[] = "'".addslashes($r->text)."': '".addslashes($r->value)."'";
            }
            $input_script .=
            "'region': {
                title: '".addslashes(JText::_('COM_IPROPERTY_REGION'))."',
                tag: 'select',
                parameter: 'region',
                value: {".implode(',', $regions)."},
                group: 'location',
                selected: false
            },";
        }

        //Counties
        if($this->params->get('adv_show_county', $settings->adv_show_county)){
            $lists['counties']  = ipropertyHTML::county_select_list('', '', '', true);
            
            $counties = array();
            foreach($lists['counties'] as $c){
                if($c->value) $counties[] = "'".addslashes($c->text)."': '".addslashes($c->value)."'";
            }
            $input_script .=
            "'county': {
                title: '".addslashes(JText::_('COM_IPROPERTY_COUNTY'))."',
                tag: 'select',
                parameter: 'county',
                value: {".implode(',', $counties)."},
                group: 'location',
                selected: false
            },";
        }

        //State
        if($this->params->get('adv_show_locstate', $settings->adv_show_locstate)){
            $lists['states']    = ipropertyHTML::state_select_list('', '', '', true, true);

            $states = array();
            foreach($lists['states'] as $s){
                if($s->value) $states[] = "'".addslashes($s->text)."': ".(int)$s->value;
            }
            $input_script .=
            "'locstate': {
                title: '".addslashes(JText::_('COM_IPROPERTY_STATE'))."',
                tag: 'select',
                parameter: 'locstate',
                value: {".implode(',', $states)."},
                group: 'location',
                selected: false
            },";
        }

        //Provinces
        if($this->params->get('adv_show_province', $settings->adv_show_province)){
            $lists['provinces'] = ipropertyHTML::province_select_list('', '', '', true);
            
            $provinces = array();
            foreach($lists['provinces'] as $pr){
                if($pr->value) $provinces[] = "'".addslashes($pr->text)."': '".addslashes($pr->value)."'";
            }
            $input_script .=
            "'province': {
                title: '".addslashes(JText::_('COM_IPROPERTY_PROVINCE'))."',
                tag: 'select',
                parameter: 'province',
                value: {".implode(',', $provinces)."},
                group: 'location',
                selected: false
            },";
        }        

        //Country
        if($this->params->get('adv_show_country', $settings->adv_show_country)){
            $lists['countries'] = ipropertyHTML::country_select_list('', '', '', true, true);
            
            $countries = array();
            foreach($lists['countries'] as $c){
                if($c->value) $countries[] = "'".addslashes($c->text)."': ".(int)$c->value;
            }
            $input_script .=
            "'country': {
                title: '".addslashes(JText::_('COM_IPROPERTY_COUNTRY'))."',
                tag: 'select',
                parameter: 'country',
                value: {".implode(',', $countries)."},
                group: 'location',
                selected: false
            },";
        }
        
        //Radius
        if($this->params->get('adv_show_radius', $settings->adv_show_radius)){
            $ranges = array( .5, 1, 1.5, 2, 5, 10, 15, 25 );
            $radius = array();
            
            $conversion = $settings->measurement_units ? 1 : 1609.344;
            
            foreach ($ranges as $r){
                $radius[] = $r.":".($r*$conversion);
            }
            
            $input_script .=
            "'rad': {
                id: 'centerRadius',
                title: '".addslashes(JText::_('COM_IPROPERTY_RADIUS'))."',
                tag: 'select',
                parameter: 'rad',
                value: {".implode(',', $radius)."},
                group: 'stype',
                selected: false
            },";
        }        

        //REO
        if($this->params->get('adv_show_reo', $settings->adv_show_reo)){
            $input_script .=
            "'reo': {
                title: '".addslashes(JText::_('COM_IPROPERTY_REO'))."',
                tag: 'input',
                type: 'checkbox',
                parameter: 'reo',
                group: 'stype',
                checked: false
            },";
        }

        //HOA
        if($this->params->get('adv_show_hoa', $settings->adv_show_hoa)){
            $input_script .=
            "'hoa': {
                title: '".addslashes(JText::_('COM_IPROPERTY_HOA'))."',
                tag: 'input',
                type: 'checkbox',
                parameter: 'hoa',
                group: 'stype',
                checked: false
            },";
        }

        //Waterfront
        if($this->params->get('adv_show_wf', $settings->adv_show_wf)){
            $input_script .=
            "'waterfront': {
                title: '".addslashes(JText::_('COM_IPROPERTY_WATER_FRONT'))."',
                tag: 'input',
                type: 'checkbox',
                parameter: 'waterfront',
                group: 'stype',
                checked: false
            },";
        }

        //Property types (check boxes)
        $cats = ipropertyHTML::getCategories();
        foreach($cats as $cat){
            $input_script .=
            "'cat".$cat->value."': {
                title: '".addslashes($cat->text)."',
				tag: 'input',
				type: 'checkbox',
				group: 'ptypes',
				parameter: 'ptype',
				custom: true,
				value: ".$cat->value.",
                selected: false
			},";
        }
      
        return substr($input_script, 0, -1);
    }

    protected function _getSliders($settings)
    {
        $slider_script = '';
        $lists = array();

        $max_price  = $this->params->get('adv_price_high', $settings->adv_price_high);
        $min_price  = $this->params->get('adv_price_low', $settings->adv_price_low);
        $max_beds   = $this->params->get('adv_beds_high', $settings->adv_beds_high);
        $min_beds   = $this->params->get('adv_beds_low', $settings->adv_beds_low);
        $max_baths  = $this->params->get('adv_baths_high', $settings->adv_baths_high);
        $min_baths  = $this->params->get('adv_baths_low', $settings->adv_baths_low);
        $max_sqft   = $this->params->get('adv_sqft_high', $settings->adv_sqft_high);
        $min_sqft   = $this->params->get('adv_sqft_low', $settings->adv_sqft_low);
        $no_limit   = $this->params->get('adv_nolimit', $settings->adv_nolimit);
        $currency   = $this->params->get('currency', $settings->currency);
        $currency_pos = $this->params->get('currency_pos', $settings->currency_pos);

        $sqft_header = ($settings->measurement_units) ? JText::_('COM_IPROPERTY_SQMDD') : JText::_('COM_IPROPERTY_SQFTDD');

        $sliders = array();
        if($this->params->get('show_price_sliders', 1)){
            $sliders[] =
            "'price': {
                title: '".addslashes(JText::_('COM_IPROPERTY_PRICE'))."',
                steps: 300,
                range: [".$min_price.", ".$max_price."],
                noLimit: ".$no_limit.",
                labelUnit: '".$currency."',
                labelPos: '".$currency_pos."',
                start: {
                    parameter: 'price_low',
                    initialStep: ".$min_price.",
                    offset: 2
                },
                end: {
                    parameter: 'price_high',
                    initialStep: ".$max_price."
                }
            }";
        }
        
        if($this->params->get('show_beds_sliders', 1)){
            $sliders[] = 
            "'beds': {
                title: '".addslashes(JText::_('COM_IPROPERTY_BEDS'))."',
                steps: ".($max_beds - $min_beds).",
                snap: true,
                range: [".$min_beds.", ".$max_beds."],
                noLimit: ".$no_limit.",
                start: {
                    parameter: 'beds_low',
                    initialStep: ".$min_beds.",
                    offset: 2
                },
                end: {
                    parameter: 'beds_high',
                    initialStep: ".$max_beds."
                }
            }";
        }
        
        if($this->params->get('show_baths_sliders', 1)){
            $sliders[] = 
            "'baths': {
                title: '".addslashes(JText::_('COM_IPROPERTY_BATHS'))."',
                steps: ".($max_baths - $min_baths).",
                snap: true,
                range: [".$min_baths.", ".$max_baths."],
                noLimit: ".$no_limit.",
                start: {
                    parameter: 'baths_low',
                    initialStep: ".$min_baths.",
                    offset: 2
                },
                end: {
                    parameter: 'baths_high',
                    initialStep: ".$max_baths."
                }
            }";
        }
        
        if($this->params->get('show_sqft_sliders', 1)){        
            $sliders[] = 
            "'sqft': {
                title: '".addslashes($sqft_header)."',
                steps: ".($max_sqft - $min_sqft).",
                range: [".$min_sqft.", ".$max_sqft."],
                noLimit: ".$no_limit.",
                start: {
                    parameter: 'sqft_low',
                    initialStep: ".$min_sqft.",
                    offset: 2
                },
                end: {
                    parameter: 'sqft_high',
                    initialStep: ".$max_sqft."
                }
            }";
        }
        
        
        if(count($sliders)){
            $x = 0;
            foreach($sliders as $s){
                $slider_script .= $s;
                $x++;
                if($x < count($sliders)) $slider_script .= ",\n";
            }
        }
        return $slider_script;
    }
}

?>