<?php
/**
 * @version 2.0 2012-03-07
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the Thinkery
 * @license GNU/GPL see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.view');

class IpropertyViewCompanyAgents extends JView
{
	function display($tpl = null)
	{
		$app  = JFactory::getApplication();
        $option     = JRequest::getCmd('option');
        
		JHTML::_('behavior.tooltip');
        JPluginHelper::importPlugin( 'iproperty' );
        $dispatcher = JDispatcher::getInstance();
	
		$featured = '';
        $this->ipbaseurl    = JURI::root(true);
        $document           = JFactory::getDocument();
		$settings           = ipropertyAdmin::config();
        $this->ipauth       = new ipropertyHelperAuth();

        $document->addStyleSheet($this->ipbaseurl.'/components/com_iproperty/assets/css/'.$settings->css_file);
        $document->addScript($this->ipbaseurl.'/components/com_iproperty/assets/js/ipcommon.js');	
		
		$model          = $this->getModel();
		$agents		    = $this->get('data');
        $company        = $this->get('company');
		$pagination     = $this->get('Pagination');
        if($settings->agent_show_featured) $featured = $this->get('featured');
        
        if(!$company){
            $this->_displayNoResult('noresult');
            return;
        }
        
        //create toolbar
        $dispatcher->trigger( 'onBeforeRenderToolbar', array( &$settings ) );
		$extra = array();
		echo ipropertyHTML::buildToolbar();

        //search criteria
        $search         = $this->get('search');
		$sort           = $this->get('sort');
		$order          = $this->get('order');

		$lists = array();
        $lists['sort']      = ipropertyHTML::buildAgentSortList($sort, 'class="inputbox"');
        $lists['order']     = ipropertyHTML::buildOrderList($order, 'class="inputbox"');
        $lists['search']    = $search;        
	
		$co_photo_width         = ( $settings->company_photo_width ) ? $settings->company_photo_width : '90';
        $agent_photo_width      = ( $settings->agent_photo_width ) ? $settings->agent_photo_width : '90';
        $accent_color           = ( $settings->accent ) ? $settings->accent : '#d2e4ea';
		$secondary_accent       = ( $settings->secondary_accent ) ? $settings->secondary_accent : '#deeaff';
        $company_folder         = $this->ipbaseurl.'/media/com_iproperty/companies/';
        $agents_folder          = $this->ipbaseurl.'/media/com_iproperty/agents/';
        $thumb_width            = ( $settings->thumbwidth ) ? $settings->thumbwidth . 'px' : '200px';
		$thumb_height           = round((( $thumb_width ) / 1.5 ), 0) . 'px';
        $enable_featured        = $settings->show_featured;
        $picfolder              = $this->ipbaseurl.$settings->imgpath;

        $this->assignRef('agents', $agents);
        $this->assignRef('company', $company);
		$this->assignRef('lists', $lists);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('settings', $settings);
        $this->assignRef('featured', $featured);
		$this->assignRef('company_photo_width', $co_photo_width);
        $this->assignRef('agent_photo_width', $agent_photo_width);
        $this->assignRef('accent_color', $accent_color);
        $this->assignRef('secondary_accent', $secondary_accent);
        $this->assignRef('company_folder', $company_folder);
        $this->assignRef('agents_folder', $agents_folder);
        $this->assignRef('thumb_width', $thumb_width);
        $this->assignRef('thumb_height', $thumb_height);
        $this->assignRef('enable_featured', $enable_featured);
        $this->assignRef('folder', $picfolder);
        $this->assignRef('dispatcher', $dispatcher);

        $this->_prepareDocument($company);
		parent::display($tpl);
	}

    protected function _prepareDocument($company)
    {
        $app            = JFactory::getApplication();
		$menus          = $app->getMenu();
		$pathway        = $app->getPathway();
		$this->params   = $app->getParams();
		$title          = null;

        $menu = $menus->getActive();
		if ($menu) {
			$this->params->def('page_heading', $this->params->get('page_title', $menu->title));
		} else {
			$this->params->def('page_heading', JText::_( 'COM_IPROPERTY_INTELLECTUAL_PROPERTY' ));
		}

        $title = (is_object($menu) && $menu->query['view'] == 'companyagents') ? $this->params->get('page_title', $company->name.' '.JText::_( 'COM_IPROPERTY_AGENTS' )) : $company->name.' '.JText::_( 'COM_IPROPERTY_AGENTS' );
        $this->iptitle = $title;
        if (empty($title)) {
			$title = $app->getCfg('sitename');
		}
		elseif ($app->getCfg('sitename_pagetitles', 0) == 1) {
			$title = JText::sprintf('JPAGETITLE', $app->getCfg('sitename'), $title);
		}
		elseif ($app->getCfg('sitename_pagetitles', 0) == 2) {
			$title = JText::sprintf('JPAGETITLE', $title, $app->getCfg('sitename'));
		}
		$this->document->setTitle($title);

        // Set meta data according to menu params
        if ($this->params->get('menu-meta_description')) $this->document->setDescription($this->params->get('menu-meta_description'));
        if ($this->params->get('menu-meta_keywords')) $this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
        if ($this->params->get('robots')) $this->document->setMetadata('robots', $this->params->get('robots'));

        // set meta keywords
        $orig_metakey = $this->document->getMetaData('keywords');
        if( $company->name ) $orig_metakey .= ','.$company->name;
        $this->document->setMetaData( "keywords", $orig_metakey);

        // set meta description
		$orig_metadesc = $this->document->getMetaData('description');
        if( $company->name ) $orig_metadesc .= '. '.$company->name;
		$this->document->setMetaData( "description", $orig_metadesc);

		// Breadcrumbs
        if(is_object($menu) && $menu->query['view'] != 'companyagents') {
			$pathway->addItem($title);
		}
	}
    
    function _displayNoResult($tpl = null)
    {
        $app  = JFactory::getApplication();
        $option     = JRequest::getCmd('option');

        $document       = JFactory::getDocument();
        $settings       = ipropertyAdmin::config();
        $accent_color   = ( $settings->accent ) ? $settings->accent : '#d2e4ea';

        $document->setTitle( JText::_( 'COM_IPROPERTY_NO_RESULTS' ) );
        $this->assignRef('accent_color', $accent_color);

        parent::display($tpl);
    }
}

?>
