<?php
/**
 * @version 2.0 2012-03-07
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the Thinkery
 * @license GNU/GPL see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.view');

class IpropertyViewCompanyProperties extends JView
{
	function display($tpl = null)
	{
		$app  = JFactory::getApplication();
        $option     = JRequest::getCmd('option');
        
		JHTML::_('behavior.tooltip');
        JPluginHelper::importPlugin( 'iproperty' );
        $dispatcher = JDispatcher::getInstance();
	
		$featured = '';
        $this->ipbaseurl    = JURI::root(true);
        $document           = JFactory::getDocument();
		$settings           = ipropertyAdmin::config();
        $this->ipauth       = new ipropertyHelperAuth();

        $document->addStyleSheet($this->ipbaseurl.'/components/com_iproperty/assets/css/'.$settings->css_file);
        $document->addScript($this->ipbaseurl.'/components/com_iproperty/assets/js/ipcommon.js');
		
		$model          = $this->getModel();
		$properties		= $this->get('data');
        $company        = $this->get('company');
		$pagination     = $this->get('Pagination');
        if($settings->show_featured) $featured = $this->get('featured');
        
        if(!$company){
            $this->_displayNoResult('noresult');
            return;
        }
        
        //create toolbar
        $dispatcher->trigger( 'onBeforeRenderToolbar', array( &$settings ) );
		$extra = array();
		echo ipropertyHTML::buildToolbar('companyproperties', $extra);

        //search criteria
        $stype          = $this->get('stype');
        $ptype          = $this->get('ptype');
		$city           = $this->get('city');
		$curstate       = $this->get('curstate');
        $province       = $this->get('province');
        $county         = $this->get('county');
        $region         = $this->get('region');
        $country        = $this->get('country');
        $beds           = $this->get('beds');
        $baths          = $this->get('baths');
        $search         = $this->get('search');
        $price_low      = $this->get('pricelow');
        $price_high     = $this->get('pricehigh');
        $sort           = $this->get('sort');
        $order          = $this->get('order');

		$lists = array();
		$lists['sort']      = ipropertyHTML::buildSortList($sort, 'class="inputbox"');
        $lists['order']     = ipropertyHTML::buildOrderList($order, 'class="inputbox"');
        $lists['cat']       = ipropertyHTML::multicatSelectList('cat','class="inputbox"', $ptype);
        $lists['stype']     = ipropertyHTML::stype_select_list('stype','class="inputbox"', $stype, true);
        $lists['city']      = ipropertyHTML::city_select_list('city','class="inputbox"', $city);
        $lists['state']     = ipropertyHTML::state_select_list('locstate','class="inputbox"', $curstate, true);
        $lists['province']  = ipropertyHTML::province_select_list('province','class="inputbox"', $province);
        $lists['county']    = ipropertyHTML::county_select_list('county','class="inputbox"', $county);
        $lists['region']    = ipropertyHTML::region_select_list('region','class="inputbox"', $region);
        $lists['country']   = ipropertyHTML::country_select_list('country','class="inputbox"', $country, true);
        $lists['beds']      = ipropertyHTML::beds_select_list('beds','class="inputbox"', $beds);
        $lists['baths']     = ipropertyHTML::baths_select_list('baths','class="inputbox"', $baths,0);
        $lists['search']    = $search;
        $lists['price_low'] = $price_low;
        $lists['price_high']= $price_high;
	
		$co_photo_width = ( $settings->company_photo_width ) ? $settings->company_photo_width : '90';
        $accent_color = ( $settings->accent ) ? $settings->accent : '#d2e4ea';
		$secondary_accent = ( $settings->secondary_accent ) ? $settings->secondary_accent : '#deeaff';
        $company_folder = $this->ipbaseurl.'/media/com_iproperty/companies/';
        $thumb_width = ( $settings->thumbwidth ) ? $settings->thumbwidth . 'px' : '200px';
		$thumb_height = round((( $thumb_width ) / 1.5 ), 0) . 'px';
        $enable_featured = $settings->show_featured;
        $picfolder = $this->ipbaseurl.$settings->imgpath;

        $this->assignRef('properties', $properties);
        $this->assignRef('company', $company);
		$this->assignRef('lists', $lists);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('settings', $settings);
        $this->assignRef('featured', $featured);
		$this->assignRef('company_photo_width', $co_photo_width);
        $this->assignRef('accent_color', $accent_color);
        $this->assignRef('secondary_accent', $secondary_accent);
        $this->assignRef('company_folder', $company_folder);
        $this->assignRef('thumb_width', $thumb_width);
        $this->assignRef('thumb_height', $thumb_height);
        $this->assignRef('enable_featured', $enable_featured);
        $this->assignRef('folder', $picfolder);
        $this->assignRef('dispatcher', $dispatcher);

        $this->_prepareDocument($company);
		parent::display($tpl);
	}

    protected function _prepareDocument($company)
    {
        $app            = JFactory::getApplication();
		$menus          = $app->getMenu();
		$pathway        = $app->getPathway();
		$this->params   = $app->getParams();
		$title          = null;

        $menu = $menus->getActive();
		if ($menu) {
			$this->params->def('page_heading', $this->params->get('page_title', $menu->title));
		} else {
			$this->params->def('page_heading', JText::_( 'COM_IPROPERTY_INTELLECTUAL_PROPERTY' ));
		}

        $title = (is_object($menu) && $menu->query['view'] == 'companyproperties') ? $this->params->get('page_title', $company->name.' '.JText::_( 'COM_IPROPERTY_PROPERTIES' )) : $company->name.' '.JText::_( 'COM_IPROPERTY_PROPERTIES' );
        $this->iptitle = $title;
        if (empty($title)) {
			$title = $app->getCfg('sitename');
		}
		elseif ($app->getCfg('sitename_pagetitles', 0) == 1) {
			$title = JText::sprintf('JPAGETITLE', $app->getCfg('sitename'), $title);
		}
		elseif ($app->getCfg('sitename_pagetitles', 0) == 2) {
			$title = JText::sprintf('JPAGETITLE', $title, $app->getCfg('sitename'));
		}
		$this->document->setTitle($title);

        // Set meta data according to menu params
        if ($this->params->get('menu-meta_description')) $this->document->setDescription($this->params->get('menu-meta_description'));
        if ($this->params->get('menu-meta_keywords')) $this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
        if ($this->params->get('robots')) $this->document->setMetadata('robots', $this->params->get('robots'));

        // set meta keywords
        $orig_metakey = $this->document->getMetaData('keywords');
        if( $company->name ) $orig_metakey .= ','.$company->name;
        $this->document->setMetaData( "keywords", $orig_metakey);

        // set meta description
		$orig_metadesc = $this->document->getMetaData('description');
        if( $company->name ) $orig_metadesc .= '. '.$company->name;
		$this->document->setMetaData( "description", $orig_metadesc);

		// Breadcrumbs
        if(is_object($menu) && $menu->query['view'] != 'companyproperties') {
			$pathway->addItem($title);
		}
	}
    
    function _displayNoResult($tpl = null)
    {
        $app  = JFactory::getApplication();
        $option     = JRequest::getCmd('option');

        $document       = JFactory::getDocument();
        $settings       = ipropertyAdmin::config();
        $accent_color   = ( $settings->accent ) ? $settings->accent : '#d2e4ea';

        $document->setTitle( JText::_( 'COM_IPROPERTY_NO_RESULTS' ) );
        $this->assignRef('accent_color', $accent_color);

        parent::display($tpl);
    }
}

?>
