<?php
/**
 * @version 2.0 2012-03-07
 * @package Joomla
 * @subpackage Intellectual Property
 * @copyright (C) 2012 the Thinkery
 * @license GNU/GPL see LICENSE.php
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

$munits     = (!$this->settings->measurement_units) ? JText::_( 'COM_IPROPERTY_SQFT' ) : JText::_( 'COM_IPROPERTY_SQM' );
$border     = ($this->p->featured) ? ' border: solid 1px ' . $this->settings->featured_accent . ';' : '';
$span_style = ($this->p->featured) ? ' style="color: ' . $this->settings->featured_accent . ';"' : '';
?>

<tr class="iprow<?php echo $this->k; ?>">
	<td width="10%" valign="top">
		<div class="property_thumb_holder" style="width: <?php echo $this->thumb_width; ?>; height: <?php echo $this->thumb_height; ?>;<?php echo $border; ?>">
			<?php echo ipropertyHTML::displayBanners($this->p->stype, $this->p->new, $this->ipbaseurl, $this->settings, $this->p->updated); ?>
            <?php echo ipropertyHTML::getThumbnail($this->p->id, $this->p->proplink, $this->p->street_address, $this->thumb_width, 'class="ip_overview_thumb"'); ?>
        </div>
        <div class="prop_overview_price" align="right">
        	<?php echo $this->p->formattedprice; ?>
        </div>
	</td> 
	<td width="90%" valign="top">
        <?php if($this->ipauth->canEditProp($this->p->id)) echo '<div class="iplistaction">'.JHtml::_('icon.edit', $this->p, 'property', false, true).'</div>'; ?>
        <?php if( $this->p->featured ): ?>
            <div class="property_overview_mlstitle">            
                <div class="property_overview_bannerright">
                    <?php echo JHTML::_('image.site', 'banner_hot.png','/components/com_iproperty/assets/images/banners/','','',JText::_( 'COM_IPROPERTY_FEATURED' )); ?>
                </div>            
            </div>
        <?php endif; ?>
		<div class="property_overview_title">
            <a href="<?php echo $this->p->proplink; ?>"<?php echo $span_style; ?> class="property_header_accent"><?php echo $this->p->street_address; ?></a>
            <?php 
                if( $this->p->city ) echo ' - '.$this->p->city;
                if( $this->p->locstate ) echo ', '.ipropertyHTML::getstatename($this->p->locstate);
                if( $this->p->province ) echo ', '.$this->p->province;
				if( $this->p->country ) echo ' '.ipropertyHTML::getcountryname($this->p->country);
                echo '<br />';

				echo '<em>';
				if( $this->p->beds ) echo '<strong>'.JText::_( 'COM_IPROPERTY_BEDS' ).':</strong> '.$this->p->beds.' &nbsp;&nbsp;';
				if( $this->p->baths && $this->p->baths != '0.00' ) echo '<strong>'.JText::_( 'COM_IPROPERTY_BATHS' ).':</strong> '.$this->p->baths.' &nbsp;&nbsp;';
				if( $this->p->sqft ) echo '<strong>'.$munits.':</strong> '.$this->p->sqft.' &nbsp;&nbsp;';
                if( $this->p->lotsize ) echo '<strong>'.JText::_( 'COM_IPROPERTY_LOT_SIZE' ).':</strong> '.$this->p->lotsize.' &nbsp;&nbsp;';
				if( $this->p->lot_acres ) echo '<strong>'.JText::_( 'COM_IPROPERTY_LOT_ACRES' ).':</strong> '.$this->p->lot_acres.' &nbsp;&nbsp;';
                if( $this->p->county ) echo '<strong>'.JText::_( 'COM_IPROPERTY_COUNTY' ).':</strong> '.$this->p->county.' &nbsp;&nbsp;';
                if( $this->p->region ) echo '<strong>'.JText::_( 'COM_IPROPERTY_REGION' ).':</strong> '.$this->p->region.' &nbsp;&nbsp;';
                echo '</em>';
            ?>
        </div>
        
        <?php
        // display overview and listing_info if available
        echo ipropertyHTML::snippet($this->p->short_description, $this->settings->overview_char); 
        if($this->p->listing_info) echo '<div class="ip_smallfont">'.$this->p->listing_info.'</div>';
            
        // instead of calling this function - add this as part of the query
        $cats   = ipropertyHTML::getAvailableCats($this->p->id);
        if($cats){
            echo '<div class="ip_overview_catcontainer">';
            $catcount = 0;
            foreach( $cats as $c ){
                echo ipropertyHTML::getCatIcon($c, 20);
                $catcount++;
                if($catcount < count($cats)) echo ' | ';
            }
            echo '<div>';
        }
        ?>
	</td>  
</tr>
